import { UiGridForm_SectionCollapsedStateChangedEvent, UiGridFormCommandHandler, UiGridFormConfig, UiGridFormEventSource } from "../generated/UiGridFormConfig";
import { UiFormLayoutPolicyConfig } from "../generated/UiFormLayoutPolicyConfig";
import { UiField } from "./formfield/UiField";
import { UiComponent } from "./UiComponent";
import { TeamAppsUiContext } from "./TeamAppsUiContext";
import { TeamAppsEvent } from "./util/TeamAppsEvent";
export declare class UiGridForm extends UiComponent<UiGridFormConfig> implements UiGridFormCommandHandler, UiGridFormEventSource {
    readonly onSectionCollapsedStateChanged: TeamAppsEvent<UiGridForm_SectionCollapsedStateChangedEvent>;
    private $mainDiv;
    private sections;
    private layoutPoliciesFromLargeToSmall;
    private activeLayoutPolicyIndex;
    private uiFields;
    private fillRemainingHeightCheckerInterval;
    private sectionCollapseOverrides;
    constructor(config: UiGridFormConfig, context: TeamAppsUiContext);
    private addField;
    getMainDomElement(): JQuery;
    onResize(): void;
    private determineLayoutPolicyIndexToApply;
    private applyLayoutPolicy;
    setSectionCollapsed(sectionId: string, collapsed: boolean): void;
    updateLayoutPolicies(layoutPolicies: UiFormLayoutPolicyConfig[]): void;
    protected onAttachedToDom(): void;
    private ensureFillRemainingHeight;
    destroy(): void;
    addOrReplaceField(field: UiField): void;
}
